Player = Class{}
require'Animation'
require'Util'

    SPEED = 80


function Player:init(pos , map , id , texture , door )

    self.spiritsheet = texture
    self.map = map
    self.tileMapWidth = 16
    self.x = pos *  self.tileMapWidth
    self.y =  12 * self.tileMapWidth - 3
    self.startPosX , self.startPosY = self.x , self.y
    
    self.width = 32
    self.height = 32
    self.quadTable = GenarateQuad( self.spiritsheet ,  self.width  , self.height )
    self.dx = 0
    self.dy = 0
    self.interval = 0.004
    self.id = id
    self.door = door
    touchedDoor = false
    status = {['idleR'] = 'idle Right'  ,   ['idlel'] = 'idle left' ,    ['idleUp'] = 'idle up' , 
    ['idleDown']  = 'idle down',  ['movRight'] = 'move right' , ['movLeft']  = 'moving left' , 
    ['movUp'] = 'moving up' ,  ['movDown'] = 'moving down'  }
    currentState = status[self.state]
    self.animations = {
        ['idleR'] = Animation({
            texture = self.spiritsheet ,
            frames = {self.quadTable[8] }, 
            interval = 1

        }) ,
        ['idlel'] = Animation({
            texture = self.spiritsheet ,
            frames = {self.quadTable[5] }, 
            interval = 1

        })  ,
        ['idleUp'] = Animation({
            texture = self.spiritsheet ,
            frames = {self.quadTable[11] }, 
            interval = 1

        }) ,

        ['idleDown'] = Animation({
            texture = self.spiritsheet ,
            frames = {self.quadTable[2] }, 
            interval = 1

        })

        
        
        ,
        ['movRight'] = Animation({
            texture = self.spiritsheet ,
            frames = {self.quadTable[7] , self.quadTable[8] , self.quadTable[9] } ,
            interval = self.interval

        }) ,
        ['movLeft'] = Animation({
            texture = self.spiritsheet , 
            frames = {self.quadTable[4] ,self.quadTable[5] , self.quadTable[6]} , 
            interval = self.interval


        }) ,
        ['movUp'] = Animation({
            texture = self.spiritsheet , 
            frames = {self.quadTable[10] ,self.quadTable[11] , self.quadTable[12]} , 
            interval = self.interval


        }) ,
        ['movDown'] = Animation({
            texture = self.spiritsheet , 
            frames = {self.quadTable[1] ,self.quadTable[2] , self.quadTable[3]} , 
            interval = self.interval


        })
    }

    self.animation = self.animations['idleDown']
  

    self.behavior = {

        ['idleR'] = function (dt)

            if love.keyboard.isDown('d') then

                CheckMoveRight( self )
                
            elseif love.keyboard.isDown('a') then

                CheckMoveLeft( self )

            elseif love.keyboard.isDown('w') then
                
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
                
                CheckMoveDown( self )
            else
                self.animation = self.animations['idleR']
                self.dx = 0
                self.dy = 0
                self.state ='idleR'

            end
            -- body
        end ,
        
        ['idlel'] = function (dt)

            if love.keyboard.isDown('d') then
                CheckMoveRight( self )
            elseif love.keyboard.isDown('a') then
                CheckMoveLeft( self )
            elseif love.keyboard.isDown('w') then
                
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
               
                CheckMoveDown( self )

            else
                self.dx = 0
                self.dy = 0
                self.animation = self.animations['idlel']
                self.state ='idlel'

            end
            -- body
        end ,
        ['idleUp'] = function (dt)

            if love.keyboard.isDown('d') then
                CheckMoveRight( self )
            elseif love.keyboard.isDown('a') then
                CheckMoveLeft( self )
            elseif love.keyboard.isDown('w') then
               
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
               
                CheckMoveDown( self )
            else
                self.animation = self.animations['idleUp']
                self.dx = 0
                self.dy = 0
                self.state ='idleUp'

            end
            -- body
        end ,
        ['idleDown'] = function (dt)

            if love.keyboard.isDown('d') then
                CheckMoveRight( self )
            elseif love.keyboard.isDown('a') then

                CheckMoveLeft( self )

            elseif love.keyboard.isDown('w') then
               
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
               
                CheckMoveDown( self )
            else
                self.animation = self.animations['idleDown']
                self.dx = 0
                self.dy = 0
                self.state ='idleDown'

            end
            -- body
        end


        
        
        ,

        ['movRight'] = function (dt)
            if love.keyboard.isDown('d') then
                CheckMoveRight( self )
            elseif love.keyboard.isDown('a') then
                CheckMoveLeft( self )
            elseif love.keyboard.isDown('w') then
                
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
               
                CheckMoveDown( self )

            else
                self.animation = self.animations['idleR']
                self.dx = 0
                self.dy = 0
                self.state ='idleR'

            end

            
        end , 
        ['movLeft'] = function (dt)

            if love.keyboard.isDown('d') then
               
                CheckMoveRight( self )

            elseif love.keyboard.isDown('a') then
               
                CheckMoveLeft( self )

            elseif love.keyboard.isDown('w') then
                
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
                
                CheckMoveDown( self )

            else
                self.dx= 0
                self.dy = 0
                self.animation = self.animations['idlel']
                self.state ='idlel'

            end


            
        end ,
        ['movUp'] = function (dt)

            if love.keyboard.isDown('d') then
                CheckMoveRight( self )
            elseif love.keyboard.isDown('a') then
                CheckMoveLeft( self )
            elseif love.keyboard.isDown('w') then
               
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then
                
                CheckMoveDown( self )

            else
                self.animation = self.animations['idleUp']
                self.dx= 0
                self.dy = 0
                self.state ='idleUp'

            end



            
        end ,
        ['movDown'] = function (dt)


            if love.keyboard.isDown('d') then
                CheckMoveRight( self )
            elseif love.keyboard.isDown('a') then
                CheckMoveLeft( self )
            elseif love.keyboard.isDown('w') then
                
                CheckMoveUp( self )

            elseif love.keyboard.isDown('s') then

                CheckMoveDown( self )
                
            else
                self.animation = self.animations['idleDown']
                self.dx= 0
                self.dy = 0
                self.state ='idleDown'

            end
            
        end
 }
    self.state = 'idleDown'

    self.Collision = {
        ['idleR'] = function (dt)


            
        end,
        ['idlel'] = function (dt)


            
        end,
        ['idleUp'] = function (dt)


            
        end,
        ['idleDown'] = function (dt)


            
        end,

        ['movRight'] = function (dt)

            if 
            self.map:Collide(self.map:TileAt(self.x + self.width ,self.y + self.height ))  then
                self.dx = 0
               --self.x = (self.map:TileAt(self.x + self.width  , self.y + self.height).x )  * self.map.tileWidth 
              -- self.state = 'idleR'
            end
            
        end ,
        ['movLeft'] = function (dt)

            if 
            self.map:Collide(self.map:TileAt(self.x  ,self.y + self.height ))  then
                self.dx = 0
                --self.x = (self.map:TileAt(self.x , self.y ).x ) * self.map.tileWidth 
               -- self.state = 'idlel'
            end
            
        end ,
        ['movUp'] = function (dt)

            if self.map:Collide(self.map:TileAt(self.x + self.width / 2  ,self.y )) or 
            self.map:Collide(self.map:TileAt(self.x  + self.width / 2  ,self.y + self.height ))  then
                self.dy = 0
               -- self.state = 'idleUp'
            end
            
        end ,
        ['movDown'] = function (dt)
            if self.map:Collide(self.map:TileAt(self.x + self.width / 2  - 5,self.y + self.height + 2 )) or 
            self.map:Collide(self.map:TileAt(self.x + self.width / 2  + 5 ,self.y + self.height + 2 )) then
                self.dy = 0
                self.y = self.y - 1 * dt
               -- self.state = 'idleDown'
            end
            
        end

    }

    






  
end

function Player:update(dt)
    self.animation:update(dt * 3)
    self.behavior[self.state ](dt)
    self.Collision[self.state](dt)
    if CheckKey(self) then
        haveKey = true
    end

 
--    touchedDoor = CheckDoorCollision(self) 


    currentState = status[self.state]
   
    -- if love.keyboard.isDown('a') or  love.keyboard.isDown('d') or  love.keyboard.isDown('w') 
    --  or  love.keyboard.isDown('s') then

        self.x = self.x + self.dx *dt
        self.y = self.y + self.dy *dt
    --  end

   

    
end

function Player:render()

   
    love.graphics.draw(self.spiritsheet , self.animation:getCurrentFrame() ,math.floor( self.x + self.width / 2 ),math.floor(self.y + self.height / 2)
     ,0 ,  01 , 01 , self.width /2 , self.height / 2)
           
     
    
end

function CheckKey(self)

    if self.map:TileAt(self.x , self.y).id  == KEY   or
    self.map:TileAt(self.x + self.width, self.y).id  == KEY or 
    self.map:TileAt(self.x , self.y + self.height).id == KEY or 
    self.map:TileAt(self.x + self.width,  self.y + self.height).id == KEY then
     
        for y = 1  , self.map.mapHeight do
            for x = 1 , self.map.mapWidth do
                
                if (self.map:getTile(x,y) == KEY) then

                    self.map:setTile(x,y, FLOOR)
                end
            end

        end
        return true

    else
        return false
    end
    
end


-- function CheckDoorCollision(self)

--     if self.x < self.door.x + self.door.width
--      or self.x + self.width > self.door.x then
--         return true
--      else
--         return false
--     end


     
-- end


function CheckMoveRight( self )
    
    if self.id == 1 then 
                   
        self.dx = SPEED
        self.dy = 0
        self.animation = self.animations['movRight']
        self.state = 'movRight'

    elseif self.id == 2 then

        self.dx = -SPEED
        self.dy = 0
        self.animation = self.animations['movLeft']
        self.state = 'movLeft'
    end 

end
function CheckMoveLeft( self )
    if self.id == 1 then 

        self.dx = -SPEED
        self.dy = 0
        self.animation = self.animations['movLeft']
        self.state = 'movLeft'
    elseif self.id == 2 then
        self.dx = SPEED
        self.dy = 0
        self.animation = self.animations['movRight']
        self.state = 'movRight'
    end
    
end

function CheckMoveUp( self )
   
    self.dx = 0
    self.dy = -SPEED
    self.animation = self.animations['movUp']
    self.state = 'movUp'
end
function CheckMoveDown( self )
    
    self.dx = 0
    self.dy = SPEED
    self.animation = self.animations['movDown']
    self.state = 'movDown'

end