chest = Class{}

function chest:init(map , posX , posY )


    self.map = map
    self.x = posX * map.tileWidth
    self.y = map.tileWidth * posY 
    self.collided = false
    self.width = 16 
    self.height = 16
    self.texture = love.graphics.newImage('graphics/chest_spritesheet.png') 
    self.opened =  love.graphics.newImage('graphics/chest_open.png')
    self.frames = GenarateQuad(self.texture , self.width , self.height)

    self.animations = {
        ['frames'] = Animation({

            texture = self.texture ,
            frames =  self.frames ,
            interval = 0.1
            
        })
    }
    self.currentAnimation = self.animations['frames']

end

function chest:update(dt )
    
    self.currentAnimation:update(dt * 4)

end






function chest:Collide(box)

    if self.x > box.x + box.width or self.x + self.width < box.x then
        return false
    end
    if self.y > box.y + box.height or self.y + self.height < box .y then 
        return false
    end

    return true
 
end





function chest:render()


    if not self.collided then

        love.graphics.draw(self.texture ,self.currentAnimation:getCurrentFrame(), self.x , self.y)
    else
        love.graphics.draw(self.opened , self.x , self.y) 
    
    end
    

end

 


