enemy = Class{}


function enemy:init(map , posX  ,posY , texture , width , height)
    
    self.width = width
    self.height = height
    self.map = map
    self.mapTileWidth = map.tileWidth
    self.mapTileHeight = map.tileHeight
    self.texture = texture
    self.x = posX * self.mapTileWidth
    self.y = posY * self.mapTileHeight
    self.startPosX = self.x
    self.startPosY = self.y
    self.frames = GenarateQuad (self.texture , self.width , self.height)
    local Speed = 30
    self.dx = Speed
    self.dy = 0
    self.state = 'right'
    self.stats ={'right' , 'left' , 'up' , 'down'}
    self.scalx = 1
    self.animations = {
        ['frames'] = Animation({

            texture = self.texture ,
            frames =  self.frames ,
            interval = 0.1
            
        })
}
    self.collisions = {
        ['right'] = function (dt)
            self.dx = Speed
            self.scalx = 1
           -- self.dy = 0
            if 
            self.map:Collide(self.map:TileAt(self.x + self.width ,self.y + self.height ))  then
                self.dx = 0
                -- if math.random(10) == 6 then
                -- self.state = 'left'
                -- else
                --     self.state = 'up' 
                -- end
                self.state = self.stats[math.random(4)]
            end


        end ,
        ['left'] = function (dt)
            self.dx = -Speed
            self.scalx = -1
           -- self.dy = 0
            if 
            self.map:Collide(self.map:TileAt(self.x  ,self.y + self.height ))  then
                self.dx = 0
                -- if math.random(10) == 5 then
                --     self.state = 'right'
                -- else
                --     self.state = 'down' 
                -- end
                self.state = self.stats[math.random(4)]
                
            end
            
        end ,
        ['up'] = function (dt)
          --  self.dx = 0
            self.dy = -Speed
            if self.map:Collide(self.map:TileAt(self.x + self.width / 2  ,self.y )) or 
            self.map:Collide(self.map:TileAt(self.x  + self.width / 2  ,self.y + self.height ))  then
                self.dy = 0
                -- if math.random(10) == 4 then
                --     self.state = 'left' 
                -- else
                   
                --     self.state = 'down'
                -- end
                self.state = self.stats[math.random(4)]
              
            end

        end ,
        ['down'] = function (dt)
           -- self.dx = 0
            self.dy = Speed
            if self.map:Collide(self.map:TileAt(self.x + self.width / 2  - 5,self.y + self.height + 2 )) or 
            self.map:Collide(self.map:TileAt(self.x + self.width / 2  + 5 ,self.y + self.height + 2 )) then
               self.dy = 0
                -- if math.random(10) == 3 then
                --     self.state = 'up'
                -- else
                --     self.state = 'right' 
                -- end
                self.state = self.stats[math.random(4)]
            end
            

        end


    }



end


function enemy:update(dt)
    self.animations['frames']:update(dt * 3)
    self.collisions[self.state](dt)
    self.x = self.x + self.dx * dt
    self.y = self.y + self.dy * dt


end

function enemy:render()

    love.graphics.draw(self.texture , self.animations['frames']:getCurrentFrame(),
     math.floor( self.x + self.width / 2 ),math.floor(self.y + self.height / 2) 
       ,0 , self.scalx , 1 , self.width /2 , self.height / 2)

end



function enemy:Collide(box)

    if self.x > box.x + box.width or self.x + self.width < box.x then
        return false
    end
    if self.y > box.y + box.height or self.y + self.height < box .y then 
        return false
    end

    return true
 
end