WINDOW_WIDTH = 1280
WINDOW_HEIGHT = 720
VIRTUAL_WIDTH = 432
VIRTUAL_HEIGHT = 243

push = require'push'
Class = require'class'
require'Util'
require'Map'
require'Player'
require'Door'
require'Spikes'
require'tourch'
require'objects'
require'chest'
require'enemy'
function love.load()

    math.randomseed(os.time())
    love.window.setTitle("Save Our Lives")
    largeFont = love.graphics.newFont('font.ttf' , 32)
    smallFont = love.graphics.newFont('font.ttf' , 16)
    love.graphics.setDefaultFilter('nearest' ,'nearest')
    push:setupScreen(VIRTUAL_WIDTH ,VIRTUAL_HEIGHT , WINDOW_WIDTH , WINDOW_HEIGHT ,
      {
        fullscreen = false ,
        resizable = false ,
        vsync = true ,

      }
    )

  sounds ={
    ['Win'] = love.audio.newSource('sounds/Win.wav','static') ,
    ['Key'] = love.audio.newSource('sounds/key.wav','static')  , 
    ['Dead'] = love.audio.newSource('sounds/Dead2.wav','static') ,
    ['Door'] = love.audio.newSource('sounds/door2.wav','static')

  }  
  gameState = 'play'
  playedKey = false
  win = sounds['Win']
  key = sounds['Key']
  death = sounds['Dead']
  door = sounds['Door']
  
  timerCount = 0
  timeSpentInLevel = 0
  score = 0
  totalScore = score + (500 / timeSpentInLevel)
  haveKey = false
  nextLevel = false
  spikesState = false
  map = Map(3)
  door = Door(map)
  lights = tourch(map ,11 , 0)
  lights2 = tourch(map ,15 , 0)
  spikes = Spikes(map , 9 , 5)
  redFlag = objects(map , 10 , 0, love.graphics.newImage('graphics/flag_red.png'))
  redFlag2 = objects(map , 16 , 0, love.graphics.newImage('graphics/flag_red.png'))
  greenFlag = objects(map , 17 , 0, love.graphics.newImage('graphics/flag_green.png'))
  greenFlag2 = objects(map , 9 , 0, love.graphics.newImage('graphics/flag_green.png'))
  skull = objects(map , 2 , 0, love.graphics.newImage('graphics/prisoner.png'))
  skull2 = objects(map , 23 , 0, love.graphics.newImage('graphics/prisoner.png'))
  key = objects(map , 23 , 3, love.graphics.newImage('graphics/key_silver.png'))
  treasure = chest(map , 2 , 2)
  spikes2 = Spikes(map , 1 , 4)
  spikes3 = Spikes(map , 2 , 9)
  spikes4 = Spikes(map , 9 , 9)
  spikes5 = Spikes(map , 14 , 9)
  spikes6 = Spikes(map , 16 , 9)
  spikes7 = Spikes(map , 20 , 7)
  spikes8 = Spikes(map , 25 , 13)
  levelSpikes = {spikes , spikes2, spikes3, spikes4, spikes5, spikes6, spikes7, spikes8}
  levelLights = {lights, lights2, tourch(map ,10 , 3) , tourch(map ,8 ,6) ,
  tourch(map ,8 ,10) , tourch(map , 3 ,10) , tourch(map ,18 ,10) , tourch(map ,22 ,10) ,
  tourch(map ,22 ,6)}
  randomSpikeFactor = 0
  male = love.graphics.newImage('graphics/Male 02-1.png')
  female =  love.graphics.newImage('graphics/Female 07-1.png')
  goblin = enemy(map , 5  ,4, love.graphics.newImage('graphics/goblin_run_spritesheet.png') , 16 , 16)
  goblin2 = enemy(map , 2  ,8, love.graphics.newImage('graphics/slime_run_spritesheeet.png') , 16 , 16)
  goblin3 = enemy(map , 10 ,4, love.graphics.newImage('graphics/goblin_run_spritesheet.png') , 16 , 16)
  fly = enemy(map , 15 ,8, love.graphics.newImage('graphics/fly_anim_spritesheet.png') , 16 , 16)
  player = Player(3 , map , 1 , male  , door)
  player2 = Player(22 , map , 2 , female , door)
  levelEnemies = { goblin , fly , goblin3  }


end

function  love.update(dt)

  if (gameState =='play') then 
    timerCount = timerCount + dt
    map:update(dt)
    door:update(dt * 4)

    for _,v in ipairs(levelEnemies) do 
      v:update(dt)
    end
   

    for _,light in ipairs(levelLights) do
    light:update(dt)
    end


    for _,v in ipairs(levelSpikes) do 
    randomSpikeFactor = math.random(0.1 , 4)
    v:update(dt * randomSpikeFactor)
    end

    if key:Collide(player) or key:Collide(player2) then
    haveKey = true
    end


    player:update(dt)
    player2:update(dt)
    treasure:update(dt)
    -- disToP1 = GetDistance(door , player)  
    -- disToP2 = GetDistance(door , player2) 
    -- angel = GetAngel (door , player)
    -- angel2 = GetAngel (door , player2)
    -- angelDeg =  math.deg(angel) 
    if (treasure:Collide(player) or  treasure:Collide(player2)) and not treasure.collided  then
   
        treasure.collided = true
        score = score + 200
        love.audio.play(win)
    end

    if door:Collide(player) and  door:Collide(player2)  then
       if haveKey   then 
        
        love.audio.play(win)
        timeSpentInLevel = timerCount
        totalScore = score + (500 / timeSpentInLevel)
        nextLevel = true
        gameState = 'win'
        

      end
    end

    for _,spikes in ipairs(levelSpikes) do 
      if spikes:Collide(player) or spikes:Collide(player2)   then
        love.audio.play(death)
        ResetPlayerPos()
        gameState = 'Death'
        spikesState = true
   
      else 
         spikesState = false
   
    end
    end

    for _,enemy in ipairs(levelEnemies) do 
      if enemy:Collide(player) or enemy:Collide(player2)   then
        love.audio.play(death)
        ResetPlayerPos()
        ResetEnemyPos(levelEnemies)
        gameState = 'Death'
        spikesState = true
   
      else 
         spikesState = false
   
      end
    end

 

    if haveKey  and playedKey == false then
      love.audio.play(key)
      love.audio.play(sounds['Door'])
      playedKey = true
    end

 




  end
 

    
end


-- function GetDistance(a , b)
  
--   return math.sqrt(((a.x +a.width /2) - (b.x + b.width / 2))^2 + 
--         ((a.y + a.height / 2) -(b.y + b.height / 2))^2)

-- end


-- function GetAngel(a ,b)

--     return math.atan2((a.y - b.y) , (a.x - b.x))
-- end

-- function CheckDistance(d , p , p2)

--   disP1 = GetDistance(d , p )  
--   disP2 = GetDistance(d , p2) 
--   if math.floor( disP1 ) == math.floor then
--     if math.floor( disP1 ) == d.width / 2 then
--       return true
--     else
--       return false
--     end

--   end
 

  
-- end


function love.keypressed(key)

      if key == 'enter' or  key =='return' then

        if gameState =='Death' then 
          gameState = 'play'
        elseif gameState == 'win' then
          ResetPlayerPos()
          gameState = 'play'

        end

      elseif key == 'escape' then
       
        love.event.quit() 


      end
end


function love.draw(  )
    push:apply('start')
    love.graphics.clear(0,0,0,0.5)
    love.graphics.setColor(1,1,1,1)
    love.graphics.setFont(smallFont)
    map:render()
    door:render()
    redFlag:render()
    redFlag2:render()
    greenFlag:render()
    greenFlag2:render()
    skull:render()
    skull2:render()
    if not haveKey then
    key:render()
    end
   

    for _,light in ipairs(levelLights) do
      light:render()
    end


    for _,v in ipairs(levelSpikes) do 
      v:render()
    end
    treasure:render()

    for _,v in ipairs(levelEnemies) do 
      v:render()
    end
 
    player:render()
    player2:render()
   
   
    if gameState =='play' then 
    
    --love.graphics.print("STATUS:"..currentState , 10 , 20)
    love.graphics.print("Time  :" ..tostring(math.floor(timerCount)) , 0 , 13 * map.tileWidth)
    -- if haveKey then
    --  -- love.audio.play(key)
    --   love.graphics.print("Got Key" , 10 , 30)
    --   --love.graphics.print("Time  :" ..tostring(timerCount) , 10 , 40)
    -- end

        
      love.graphics.print("Score : "..tostring(score) , 10 ,0 * map.tileWidth)
   
  
   


    if nextLevel then
     -- love.audio.play(win)
      love.graphics.print("nextLevel    "  , 10 , 50)

    end

    -- if spikesState then
    --   love.graphics.print("Death    "  , 10 , 60)
    -- else
    --   love.graphics.print("     "  , 10 , 60)
    -- end
    for _,spikes in ipairs(levelSpikes) do 
      if spikes:Collide(player) or spikes:Collide(player2)   then
        -- love.audio.play(key)
        love.graphics.print("Death    "  , 10 , 60)
   
       else 
        love.graphics.print("     "  , 10 , 60)
   
       end
    end




  end

    if gameState =='win' then
      love.graphics.setColor(1,1,0,1)
      love.graphics.setFont(largeFont)
      love.graphics.print("you win !!" , map.tileWidthPixels / 2 - 5 * map.tileWidth , map.tileHeightPixels / 2 - 2 * map.tileWidth)
      love.graphics.setFont(smallFont)

      love.graphics.print("total Time : "..tostring(math.floor(timeSpentInLevel)) , map.tileWidthPixels / 2 - 7 * map.tileWidth , map.tileHeightPixels / 2 + 2 * map.tileWidth)
      love.graphics.print("Chest bonus  : "..tostring(score) , map.tileWidthPixels / 2 - 7 * map.tileWidth , map.tileHeightPixels / 2 + 3 * map.tileWidth)
      love.graphics.print("total score  : "..tostring(math.floor(totalScore) ) , map.tileWidthPixels / 2 - 7 * map.tileWidth , map.tileHeightPixels / 2 + 4 * map.tileWidth)
      love.graphics.setColor(1,1,1,1)
      love.graphics.setFont(smallFont)

    end

    if  gameState =='Death' then

      love.graphics.print("Press Enter <-| " , 10 , 20)

    end
     --love.graphics.print("Distance P1:"..tostring(math.floor(disToP1)) , 10 , 10)
    -- love.graphics.print("Angel P1:"..tostring((angelDeg)) , 8 * map.tileWidth , 10)


    push:apply('end')

end

function ResetPlayerPos()

  player.x =player.startPosX
  player.y = player.startPosY

  player2.x =player2.startPosX
  player2.y = player2.startPosY
end


function ResetEnemyPos(enemies)

  for _,e in ipairs(enemies) do
  e.x = e.startPosX 
  e.y = e.startPosY
end


end 



